/** Store information about the ball.
 * The information included, the placement of the ball, current velocity and direction, 
 * aswell as its size, point value and horisontal movement
 */


public class Ball {
	

//	private int alive;
	public WillPangBallGen imagePane;

	
	int ballSize = 0;
	int ballPxlSize = 0;
	int ballBounceSize;
	int ballPointValue;

	int x = 0;
	int y = 0;

	private int oldX = 0;
	private int oldY = 0;

	int lastX = -1;
	int lastY = -1;

	int s = 0;
	double v;
	double u;
	
	public double horDirection;
	private double scale;

	public boolean alive = true; 
		
//	private int alive;
	private double scaleBounceFactor;
//	private int type;

//	public Ball (int x, int y, int ballSize, int initialVelocity, int horDirection, double scaleBounceFactor) {
//		
//	}

	public BallType type;
	
	public int getBallPoints () {

		return type.ballPointValue[ballSize];
	}
	
	public Ball (int x, int y, int ballSize, int initialVelocity, double horDirection, int typeNo, WillPangBallGen imagePane) {
		

		try {
		type = imagePane.types[typeNo];
		} catch (ArrayIndexOutOfBoundsException e) {
		}
		this.scaleBounceFactor = scaleBounceFactor;
		this.imagePane = imagePane;
//		this.scale = scale;

		// Initialize all of the variables
		this.x = x;
		this.y = y;
		
		this.ballSize = ballSize;
	//	System.out.println("asdf");

	//	try {
			//ballBounceSize = type.ballBounceSize[ballSize];
//		ballPointValue = type.ballPointValue[ballSize];
			

			// Wait up to 1 second
	//		int timeout = 0;
	//		while (type.balls[ballSize].getWidth(null) == -1 && timeout < 5){
	//			Delegate.doze(200);
	//			timeout++;
	//		}
			//if (type.balls[ballSize].getWidth(null) == -1) {
			//	System.out.println("Warning: ball has incorrect pixel size, may bounce erroneously");
			//}
//
//			ballPxlSize = type.balls[ballSize].getWidth(null);
//
//		} catch (Exception e) {
//			System.out.println("This ball uses an invalid ball size for this type.  Attempted Type: " + type.thisType + "  Attempted Size: " + ballSize);
//			alive = false;
//
//		}

		
//		scale = imagePane.ballGenPanel.scale;
		scale = 1;
//		ballPxlSize = scaleAndRound(ballPxlSize);
		ballBounceSize = halfScaleAndRound(ballBounceSize);
		

	//	ballBounceSize = (int) Math.round(ballBounceSize * scaleBounceFactor);
		
		this.horDirection = horDirection;

		u = initialVelocity;
		alive = true;

	}
	
	
	
	public int getBallPxlSize () {
		return ballPxlSize;
	}
	
	public void update (int x, int y, double v, int s, int horDirection) {
		this.x = x;
		this.y = y;
		this.v = v;
		this.s = s;
		this.horDirection = horDirection;
	}
	
	public void remove() {
		remove(false);
	}
	public void remove(boolean force) {
	
		int w = type.balls[ballSize].getWidth(null);
		int h = w;
		
//		x,y,w,h);
		imagePane.ballGenPanel.g.clearRect(x,y,w,h);
		//if (((oldX != x || oldY != y) && oldX != -1) || force) imagePane.willPangPanel.remoreplaceRecta(imagePane.graphics,oldX,oldY,w,h);

	
	}

	public void draw () {
		//System.out.print("d");
		try {
		imagePane.ballGenPanel.g.drawImage(type.balls[ballSize], x, y,null);
		} catch (Exception e) {
		}
		oldX = x;
		oldY = y;	
		
	}
	
	
	public void kill() {
		alive = false;
	}
	
	//Getter Methods
	public int getU () {
		return (int) u;
	}
	public int getX () {
		return x;
	}
	public int getLastX () {
		return lastX;
	}
	public int getY () {
		return y;
	}
	public int getLastY () {
		return lastY;
	}
	public double getV () {
		return v;
	}
	public int getS () {
		return s;
	}
	public double getHorDirection () {
		return horDirection;
	}	
	public int getBallSize () {
		return ballSize;
	}
	public int getBallPointValue() {
		return ballPointValue;
	}

	public String toString() {
		//B 300,20,4,0,-1
		try {
			return "B " + x + "," + y + "," + ballSize + "," + (int) u + "," + horDirection + "," + type.thisType;
		} catch (NullPointerException e) {
			return "";
		}
	}
	

	public double getScaleBounceFactor () {
		return scaleBounceFactor;
	}
//	public ballTypeint getType () {
//		return type;
//	}


	public int scaleAndRound (int number) {
		return (int) Math.round(number * scale);
	}

	public int halfScaleAndRound (int number) {
		if (scale < 2) {
			return number;
		} else {
			return number + scaleAndRound(8)-8;//(int) Math.round(number * scale /2);
		}
	}

}
	
